﻿-- Daily Global Check - Legion World Quests plugin
-- Jadya EU-Well of Eternity

local Z = DailyGlobalCheck.Z

local questsdata = {}

local list = {
 ["Title"] = "Legion World Quests",
 ["Icon"]  = "Interface\\Icons\\Achievement_BG_ABshutout",
 ["Version"] = 1004,
 ["Order"] = {
              {
			   {Z[1015]},
			   {Z[1018]},
			   {Z[1033]},
			   {Z[1024]},
			   {Z[1017]},
			   {Z[1014]},
			  },
             },
}

local function isquestcompleted(questID)
 local result = IsQuestFlaggedCompleted(questID)
 if result then return result end
 return false, SecondsToTime((C_TaskQuest.GetQuestTimeLeftMinutes(questID) or 0) * 60)
end

local function GenerateData()
 -- temporary until 7.0 goes live
 if not C_TaskQuest.GetQuestTimeLeftMinutes then return end

 local tinsert = table.insert

 local l = DailyGlobalCheck.LocalizeSection

 local function showfunc(questID)
  -- looks like C_TaskQuest.IsActive doesn't return what I need
  return C_TaskQuest.GetQuestTimeLeftMinutes(questID) ~= 0
 end

 local function checkMap(i, mapID)
  SetMapByID(mapID)
  for k,v in pairs(C_TaskQuest.GetQuestsForPlayerByMapID(mapID)) do
   tinsert(list.Order[1][i], v.questId)
   questsdata[v.questId] = {Z[mapID],l(questsdata, v.questId, 2, tostring(v.questId), "quest", v.questId),nil,nil,nil,nil,nil,nil,showfunc,isquestcompleted}
  end
 end

 local map = GetCurrentMapAreaID()

 checkMap(1, 1015) -- Azsuna
 checkMap(2, 1018) -- Val'Sharah
 checkMap(3, 1033) -- Suramar
 checkMap(4, 1024) -- Highmountain
 checkMap(5, 1017) -- Stormheim
 checkMap(6, 1014) -- Dalaran
 
 SetMapByID(map)
end

list.GenerateData = GenerateData
DailyGlobalCheck:LoadPlugin(list, questsdata)